CREATE TABLE `firstdata_e4_payment_methods` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `kb_payment_method_id` varchar(255) DEFAULT NULL,
  `token` varchar(255) DEFAULT NULL,
  `cc_first_name` varchar(255) DEFAULT NULL,
  `cc_last_name` varchar(255) DEFAULT NULL,
  `cc_type` varchar(255) DEFAULT NULL,
  `cc_exp_month` varchar(255) DEFAULT NULL,
  `cc_exp_year` varchar(255) DEFAULT NULL,
  `cc_number` varchar(255) DEFAULT NULL,
  `cc_last_4` varchar(255) DEFAULT NULL,
  `cc_start_month` varchar(255) DEFAULT NULL,
  `cc_start_year` varchar(255) DEFAULT NULL,
  `cc_issue_number` varchar(255) DEFAULT NULL,
  `cc_verification_value` varchar(255) DEFAULT NULL,
  `cc_track_data` varchar(255) DEFAULT NULL,
  `address1` varchar(255) DEFAULT NULL,
  `address2` varchar(255) DEFAULT NULL,
  `city` varchar(255) DEFAULT NULL,
  `state` varchar(255) DEFAULT NULL,
  `zip` varchar(255) DEFAULT NULL,
  `country` varchar(255) DEFAULT NULL,
  `is_deleted` tinyint(1) NOT NULL DEFAULT '0',
  `created_at` datetime NOT NULL,
  `updated_at` datetime NOT NULL,
  `kb_account_id` varchar(255) DEFAULT NULL,
  `kb_tenant_id` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `index_firstdata_e4_payment_methods_on_kb_account_id` (`kb_account_id`),
  KEY `index_firstdata_e4_payment_methods_on_kb_payment_method_id` (`kb_payment_method_id`)
) ENGINE=InnoDB CHARACTER SET utf8 COLLATE utf8_bin;

CREATE TABLE `firstdata_e4_transactions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `firstdata_e4_response_id` int(11) NOT NULL,
  `api_call` varchar(255) NOT NULL,
  `kb_payment_id` varchar(255) NOT NULL,
  `kb_payment_transaction_id` varchar(255) NOT NULL,
  `transaction_type` varchar(255) NOT NULL,
  `payment_processor_account_id` varchar(255) DEFAULT NULL,
  `txn_id` varchar(255) DEFAULT NULL,
  `amount_in_cents` int(11) DEFAULT NULL,
  `currency` varchar(255) DEFAULT NULL,
  `created_at` datetime NOT NULL,
  `updated_at` datetime NOT NULL,
  `kb_account_id` varchar(255) NOT NULL,
  `kb_tenant_id` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `index_firstdata_e4_transactions_on_kb_payment_id` (`kb_payment_id`)
) ENGINE=InnoDB CHARACTER SET utf8 COLLATE utf8_bin;

CREATE TABLE `firstdata_e4_responses` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `api_call` varchar(255) NOT NULL,
  `kb_payment_id` varchar(255) DEFAULT NULL,
  `kb_payment_transaction_id` varchar(255) DEFAULT NULL,
  `transaction_type` varchar(255) DEFAULT NULL,
  `payment_processor_account_id` varchar(255) DEFAULT NULL,
  `message` varchar(255) DEFAULT NULL,
  `authorization` varchar(255) DEFAULT NULL,
  `fraud_review` tinyint(1) DEFAULT NULL,
  `test` tinyint(1) DEFAULT NULL,
  `params_amount_requested` varchar(255) DEFAULT NULL,
  `params_authorization_num` varchar(255) DEFAULT NULL,
  `params_avs` varchar(255) DEFAULT NULL,
  `params_bank_message` varchar(255) DEFAULT NULL,
  `params_bank_resp_code` varchar(255) DEFAULT NULL,
  `params_bank_resp_code_2` varchar(255) DEFAULT NULL,
  `params_card_cost` varchar(255) DEFAULT NULL,
  `params_card_holders_name` varchar(255) DEFAULT NULL,
  `params_card_type` varchar(255) DEFAULT NULL,
  `params_cavv` varchar(255) DEFAULT NULL,
  `params_cavv_algorithm` varchar(255) DEFAULT NULL,
  `params_cavv_response` varchar(255) DEFAULT NULL,
  `params_client_email` varchar(255) DEFAULT NULL,
  `params_client_ip` varchar(255) DEFAULT NULL,
  `params_ctr` text DEFAULT NULL,
  `params_currency` varchar(255) DEFAULT NULL,
  `params_current_balance` varchar(255) DEFAULT NULL,
  `params_customer_ref` varchar(255) DEFAULT NULL,
  `params_cvd_presence_ind` varchar(255) DEFAULT NULL,
  `params_cvv2` varchar(255) DEFAULT NULL,
  `params_dollar_amount` varchar(255) DEFAULT NULL,
  `params_ean` varchar(255) DEFAULT NULL,
  `params_ecommerce_flag` varchar(255) DEFAULT NULL,
  `params_error_description` varchar(255) DEFAULT NULL,
  `params_exact_id` varchar(255) DEFAULT NULL,
  `params_error_number` varchar(255) DEFAULT NULL,
  `params_exact_message` varchar(255) DEFAULT NULL,
  `params_exact_resp_code` varchar(255) DEFAULT NULL,
  `params_language` varchar(255) DEFAULT NULL,
  `params_merchant_address` varchar(255) DEFAULT NULL,
  `params_merchant_city` varchar(255) DEFAULT NULL,
  `params_merchant_country` varchar(255) DEFAULT NULL,
  `params_merchant_name` varchar(255) DEFAULT NULL,
  `params_merchant_postal` varchar(255) DEFAULT NULL,
  `params_merchant_province` varchar(255) DEFAULT NULL,
  `params_merchant_url` varchar(255) DEFAULT NULL,
  `params_pan` varchar(255) DEFAULT NULL,
  `params_partial_redemption` varchar(255) DEFAULT NULL,
  `params_password` varchar(255) DEFAULT NULL,
  `params_previous_balance` varchar(255) DEFAULT NULL,
  `params_reference_3` varchar(255) DEFAULT NULL,
  `params_reference_no` varchar(255) DEFAULT NULL,
  `params_retrieval_ref_no` varchar(255) DEFAULT NULL,
  `params_secure_auth_required` varchar(255) DEFAULT NULL,
  `params_secure_auth_result` varchar(255) DEFAULT NULL,
  `params_sequence_no` varchar(255) DEFAULT NULL,
  `params_surcharge_amount` varchar(255) DEFAULT NULL,
  `params_tax1_amount` varchar(255) DEFAULT NULL,
  `params_tax1_number` varchar(255) DEFAULT NULL,
  `params_tax2_amount` varchar(255) DEFAULT NULL,
  `params_tax2_number` varchar(255) DEFAULT NULL,
  `params_track1` varchar(255) DEFAULT NULL,
  `params_track2` varchar(255) DEFAULT NULL,
  `params_transaction_approved` varchar(255) DEFAULT NULL,
  `params_transaction_error` varchar(255) DEFAULT NULL,
  `params_transaction_tag` varchar(255) DEFAULT NULL,
  `params_transaction_type` varchar(255) DEFAULT NULL,
  `params_transarmor_token` varchar(255) DEFAULT NULL,
  `params_verification_str1` varchar(255) DEFAULT NULL,
  `params_virtual_card` varchar(255) DEFAULT NULL,
  `params_xid` varchar(255) DEFAULT NULL,
  `params_zip_code` varchar(255) DEFAULT NULL,
  `avs_result_code` varchar(255) DEFAULT NULL,
  `avs_result_message` varchar(255) DEFAULT NULL,
  `avs_result_street_match` varchar(255) DEFAULT NULL,
  `avs_result_postal_match` varchar(255) DEFAULT NULL,
  `cvv_result_code` varchar(255) DEFAULT NULL,
  `cvv_result_message` varchar(255) DEFAULT NULL,
  `success` tinyint(1) DEFAULT NULL,
  `created_at` datetime NOT NULL,
  `updated_at` datetime NOT NULL,
  `kb_account_id` varchar(255) DEFAULT NULL,
  `kb_tenant_id` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB CHARACTER SET utf8 COLLATE utf8_bin;
